# Generated by Django 5.1.1 on 2024-09-17 17:15

import colorfield.fields
import django.db.models.deletion
from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ("core", "0065_calendarevent_update_timezone_constraints"),
    ]

    operations = [
        migrations.CreateModel(
            name="EffortType",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True, primary_key=True, serialize=False, verbose_name="ID"
                    ),
                ),
                (
                    "managed_by_app_label",
                    models.CharField(
                        blank=True,
                        editable=False,
                        max_length=255,
                        verbose_name="App label of app responsible for managing this instance",
                    ),
                ),
                ("extended_data", models.JSONField(default=dict, editable=False)),
                ("name", models.CharField(max_length=255, verbose_name="Name")),
                (
                    "color",
                    colorfield.fields.ColorField(
                        blank=True,
                        default="",
                        image_field=None,
                        max_length=25,
                        samples=None,
                        verbose_name="Color",
                    ),
                ),
                (
                    "icon",
                    models.CharField(
                        blank=True, choices=[("", "")], max_length=50, verbose_name="Icon"
                    ),
                ),
                ("default", models.BooleanField(verbose_name="Default")),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="GradeSet",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True, primary_key=True, serialize=False, verbose_name="ID"
                    ),
                ),
                (
                    "managed_by_app_label",
                    models.CharField(
                        blank=True,
                        editable=False,
                        max_length=255,
                        verbose_name="App label of app responsible for managing this instance",
                    ),
                ),
                ("extended_data", models.JSONField(default=dict, editable=False)),
                ("name", models.CharField(max_length=255, unique=True, verbose_name="Name")),
                (
                    "groups",
                    models.ManyToManyField(
                        blank=True,
                        null=True,
                        related_name="grade_sets",
                        to="core.group",
                        verbose_name="Groups using this grade set",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="GradeChoice",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True, primary_key=True, serialize=False, verbose_name="ID"
                    ),
                ),
                (
                    "managed_by_app_label",
                    models.CharField(
                        blank=True,
                        editable=False,
                        max_length=255,
                        verbose_name="App label of app responsible for managing this instance",
                    ),
                ),
                ("extended_data", models.JSONField(default=dict, editable=False)),
                ("name", models.CharField(max_length=255, verbose_name="Name")),
                ("value", models.CharField(max_length=255, verbose_name="Value")),
                ("order", models.PositiveSmallIntegerField(verbose_name="Order")),
                (
                    "grade_set",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="grade_choices",
                        to="maka.gradeset",
                        verbose_name="Grade set",
                    ),
                ),
            ],
            options={
                "verbose_name": "Grade choice",
                "verbose_name_plural": "Grade choices",
            },
        ),
        migrations.CreateModel(
            name="Effort",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True, primary_key=True, serialize=False, verbose_name="ID"
                    ),
                ),
                (
                    "managed_by_app_label",
                    models.CharField(
                        blank=True,
                        editable=False,
                        max_length=255,
                        verbose_name="App label of app responsible for managing this instance",
                    ),
                ),
                ("extended_data", models.JSONField(default=dict, editable=False)),
                ("name", models.CharField(max_length=255, verbose_name="Name")),
                ("weight", models.PositiveSmallIntegerField(default=1, verbose_name="Weight")),
                (
                    "grade_set",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to="maka.gradeset",
                        verbose_name="Grade set",
                    ),
                ),
                (
                    "group",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.PROTECT,
                        related_name="efforts",
                        to="core.group",
                        verbose_name="Group",
                    ),
                ),
                (
                    "effort_type",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="efforts",
                        to="maka.efforttype",
                        verbose_name="Effort type",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="Grade",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True, primary_key=True, serialize=False, verbose_name="ID"
                    ),
                ),
                (
                    "managed_by_app_label",
                    models.CharField(
                        blank=True,
                        editable=False,
                        max_length=255,
                        verbose_name="App label of app responsible for managing this instance",
                    ),
                ),
                ("extended_data", models.JSONField(default=dict, editable=False)),
                (
                    "person",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="grades",
                        to="core.person",
                        verbose_name="Person",
                    ),
                ),
                (
                    "grade",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to="maka.gradechoice",
                        verbose_name="Grade",
                    ),
                ),
                (
                    "effort",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="grades",
                        to="maka.effort",
                        verbose_name="Effort",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.AddConstraint(
            model_name="gradechoice",
            constraint=models.UniqueConstraint(
                fields=("grade_set", "name"), name="unique_gradeset_name"
            ),
        ),
        migrations.AddConstraint(
            model_name="gradechoice",
            constraint=models.UniqueConstraint(
                fields=("grade_set", "value"), name="unique_gradeset_value"
            ),
        ),
    ]
